%!TEX root=../../source.tex
%!TEX file=config/commands/math.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MATH SYMBOL COMMANDS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%
% @group math
% @sample \std: Standard deviation of variable $x$
% @sample \std[y]: Standard deviation of variable $y$
%
\ProvideDocumentCommand{\std}{ O{x} }{ %
  \sigma_{#1}%
}%


%%
% @group math
% @sample \var: Variance of variable $x$
% @sample \var[y]: Variance of variable $y$
%
\ProvideDocumentCommand{\var}{ O{x} }{ %
  \std[#1]^{2}%
}%


%%
% @group math
% @sample \mean: Mean value of variable $x$
% @sample \mean[y]: Mean value of variable $y$
%
\ProvideDocumentCommand{\mean}{ O{x} }{ %
  \bar{#1}%
}%


%%
% @group math
% @sample \median: Median value of variable $x$
% @sample \median[y]: Median value of variable $y$
%
\ProvideDocumentCommand{\median}{ O{x} }{ %
  \tilde{#1}%
}%


%%
% @group math
% @sample \sem: Standard error of the mean of variable $x$
% @sample \sem[y]: Standard error of the mean of variable $y$
%
\ProvideDocumentCommand{\sem}{ O{x} }{ %
  \std[\mean[#1]]%
}%


%%
% @group math
% @sample \prctile{25}: 25-th percentile
%
\ProvideDocumentCommand{\prctile}{ g }{ %
  p_{\IfValueTF{#1}{\SI{#1}{\percent}}{x\,\si{\percent}}}%
}%


%%
% @group math
% @sample \conjugate{x}: Conjugate of a variable
%%
\ProvideDocumentCommand{\conjugate}{ m }{%
  \overline{#1}%
}%


%%
% @group math
% @sample \vertbar: Vertical bar to denote column vectors inside a matrix
%%
\ProvideDocumentCommand{\vertbar}{}{%
  \rule[-1ex]{0.5pt}{2.5ex}%
}%


%%
% @group math
% @sample \horzbar: Horizontal bar to denote row vectors inside a matrix
%%
\ProvideDocumentCommand{\horzbar}{}{%
  \rule[.5ex]{2.5ex}{0.5pt}%
}%


%%
% @group math
% @sample \pdet{x}: Determinant of $x$ with parentheses around $x$
% @sample \pdet[\bigg]{x}: Determinant of $x$ with pairing parentheses' heights to \latexinline|\bigg|
% @sample \pdet*{x}: Determinant of $x$ with automatically height-adjusted parentheses around $x$
%%
\ProvideDocumentCommand{\pdet}{ s o m }{%
  \IfBooleanTF{#1}{%
    \prtrig*{\det}{#3}%
  }{%
    \IfValueTF{#2}{%
      \prtrig[#2]{\det}{#3}%
    }{%
      \prtrig{\det}{#3}%
    }%
  }%
}%

%%
% @group math
% @sample \ptrace{x}: Trace of $x$ with parentheses around $x$
% @sample \ptrace[\bigg]{x}: Trace of $x$ with pairing parentheses' heights to \latexinline|\bigg|
% @sample \ptrace*{x}: Trace of $x$ with automatically height-adjusted parentheses around $x$
%%
\ProvideDocumentCommand{\ptrace}{ s o m }{%
  \IfBooleanTF{#1}{%
    \prtrig*{\trace}{#3}%
  }{%
    \IfValueTF{#2}{%
      \prtrig[#2]{\trace}{#3}%
    }{%
      \prtrig{\trace}{#3}%
    }%
  }%
}%

% Adjugate
\ProvideMathOperator{\adj}{adj}%

% Sign of something
\ProvideMathOperator{\sgn}{sgn}%

% Rank of matrix
\ProvideMathOperator{\rank}{rank}%

% Block diagonal
\ProvideMathOperator{\blkdiag}{blockdiag}%

% Vertical concatenation
\ProvideMathOperator{\vertcat}{vertcat}%

% Horizontal concatenation
\ProvideMathOperator{\horzcat}{horzcat}%

%%
% @group math
% @sample \SO: Special orientation group $\SO{3}$
% @sample \SO[2]: Special orientation group $\SO{2}$ (whatever that may be....)
%%
\ProvideDocumentCommand{\SO}{ O{3} }{%
  \mathop{\mathrm{SO}}\of{#1}%
}%

%%
% @group math
% @sample \bigo: Bachmann–Landau notation or asymptotic notation.
%%
\ProvideDocumentCommand{\bigo}{ }{%
  \mathcal{O}%
}%

%%
% @group math
% @sample \ndot{4}{f}: Writes the $4$-th derivative of function $f$
%%
\ProvideDocumentCommand{\ndot}{ m m }{%
  #2^{\parentheses{#1}}%
}%

%%
% @group math
% @sample \tol: Prints $\varepsilon$ for variable of tolerance that needs to be satisfied
% @sample \tol[\delta]: Uses $\delta$ as variable of tolerance
%%
\ProvideDocumentCommand{\tol}{ O{\varepsilon} }{%
  #1%
}%

%%
% @group math
% @sample \stepsize: Step size of any numerical integrator or differentiator
%%
\ProvideDocumentCommand{\stepsize}{ }{%
  h%
}%

%%
% @group math
% @sample \funcindex: Index representing the $\funcindex$-th basis function
%%
\ProvideDocumentCommand{\funcindex}{ }{%
  k%
}%

%%
% @group math
% @sample \loopindex: Index of loop or iteration
%%
\ProvideDocumentCommand{\loopindex}{ }{%
  l%
}%

%%
% @group math
% @sample \factorial{x}: Write factorial function of $x$ \textIe $x!$
%%
\ProvideDocumentCommand{\factorial}{ m }{%
  #1!
}%

%%
% @group math
% @sample \padj{x}: Adjugate of $x$ with parentheses around $x$
% @sample \padj[\bigg]{x}: Adjugate of $x$ with pairing parentheses' heights to \latexinline|\bigg|
% @sample \padj*{x}: Adjugate of $x$ with automatically height-adjusted parentheses around $x$
%%
\ProvideDocumentCommand{\padj}{ s o m }{%
  \IfBooleanTF{#1}{%
    \prtrig*{\adj}{#3}%
  }{%
    \IfValueTF{#2}{%
      \prtrig[#2]{\adj}{#3}%
    }{%
      \prtrig{\adj}{#3}%
    }%
  }%
}%

%%
% @group math
% @sample \invect{a & b & c}: Place an inline vector
%%
\ProvideDocumentCommand{\invect}{ m }{%
  \begin{bsmallmatrix}%
    #1%
  \end{bsmallmatrix}%
}%

%%
% @group math
% @sample \pinv{M}: Moore-Penrose pseudo inverse of matrix $\matr{M}$
%%
\ProvideDocumentCommand{\pinv}{ s m }{%
  \IfBooleanTF{#1}{%
    \parentheses*{#2}%
  }{%
    #2%
  }%
  ^{+}%
}%

%%
% @group math
% @sample \quat: Quaternion vector
% @sample \quat*: Scalar quaternion
%%
\ProvideDocumentCommand{\quat}{ s }{%
  \IfBooleanTF{#1}{%
    \Theta%
  }{%
    \vect{\Theta}%
  }%
}%

%%
% @group math
% @sample \dotquat: First-order time-derivative of quaternion vector
% @sample \dotquat*: First-order time-derivative of scalar quaternion
%%
\ProvideDocumentCommand{\dotquat}{ s }{%
  \IfBooleanTF{#1}{%
    \dot{\Theta}%
  }{%
    \dotvect{\Theta}%
  }%
}%

%%
% @group math
% @sample \ddotquat: Second-order time-derivative of quaternion vector
% @sample \ddotquat*: Second-order time-derivative of scalar quaternion
%%
\ProvideDocumentCommand{\ddotquat}{ s }{%
  \IfBooleanTF{#1}{%
    \ddot{\Theta}%
  }{%
    \ddotvect{\Theta}%
  }%
}%

%%
% @group math
% @sample \quatratemat: Quaternion rate matrix
%%
\ProvideDocumentCommand{\quatratemat}{ }{%
  \matr{W}%
}%

%%
% @group math
% @sample \coordsys{m}: Write caligraphic coordinate system / frame center denoted with m
%%
\ProvideDocumentCommand{\coordsys}{ m }{%
  \mathcal{K}_{ \ms{#1} }%
}%

%%
% @group math
% @sample \transform{P}{0}: Place transformation matrix $T$ from system P to 0
%%
\ProvideDocumentCommand{\transform}{ O{T} m m }{%
  \matr[#2][#3]{#1}%
}%

%%
% @group math
% @sample \discretenabla: Discrete nabla operator \textIe discrete derivative of a function f
%%
\ProvideDocumentCommand{\discretenabla}{}{%
  \overline{\nabla}%
}%

%%
% @group math
% @sample \transpose{A}: Transpose of argument $A$ e.g., matrix or vector transpose
% @sample \transpose[\mkern-2.5mu]{x}: Set the spacing of the superscript index for the transpose symbol manually. This may be useful in case the superscript is too close or too far away from its base
%%
\ProvideDocumentCommand{\transpose}{ s O{\mkern-1.5mu} m }{%
  \IfBooleanTF{#1}{%
    \parentheses*{#3}^{#2\mbox{\textscale{0.6}{$\top$}}}%
  }{%
    #3^{#2\mbox{\textscale{0.6}{$\top$}}}%
  }%
  \mkern-1.0mu%
}%


%%
% @group math
% @sample \p{x}: First partial derivative of $x$ with respect some other variable rather than time $t$
%%
\ProvideDocumentCommand{\p}{ m }{%
  #1^{\prime}\mkern-1.2mu%
}

%%
% @group math
% @sample \pp{x}: Second partial derivative of $x$ with respect some other variable rather than time $t$
%%
\ProvideDocumentCommand{\pp}{ m }{%
  #1^{\prime\prime}\mkern-1.2mu%
}

%%
% @group math
% @sample \ppp{x}: Third partial derivative of $x$ with respect some other variable rather than time $t$
%%
\ProvideDocumentCommand{\ppp}{ m }{%
  #1^{\prime\prime\prime}\mkern-1.2mu%
}


%%
% @group math
% @sample \jacobiansymbol: Provides the mathematical symbol used to define the Jacobian
%%
\ProvideMathOperator{\jacobiansymbol}{D}%

%%
% @group math
% @sample \jacobian{f}: Writes the Jacobian operator onto $f$
% @sample \jacobian[x]{f}: Writes the Jacobian operator with respect to $x$ onto $f$
% @sample \jacobian*[x]{f}: Wrap the argument $f$ into auto-growing parentheses
%%
\ProvideDocumentCommand{\jacobian}{ s o O{} m }{%
  \jacobiansymbol%
  \IfValueT{#2}{_{#2}^{#3}}%
  \mkern-1.0mu%
  \IfBooleanTF{#1}{%
    \parentheses*{#4}%
  }{%
    #4%
  }%
}%

%%
% @group math
% @sample \dotjacobian: Time-derivative of Jacobian matrix of $\vect{f}$
%%
\ProvideDocumentCommand{\dotjacobian}{ m }{%
  \dot{\jacobiansymbol}\mkern-1.0mu#1%
}%

%%
% @group math
% @sample \ddotjacobian: Second time-derivative of Jacobian matrix of $\vect{f}$
%%
\ProvideDocumentCommand{\ddotjacobian}{ m }{%
  \ddot{\jacobiansymbol}\mkern-1.0mu#1%
}%

%%
% @group math
% @sample \vectft{A}{B}: typeset vector $r$ from point A to point B
% @sample \vectft[q]{A}{B}: Use $q$ as vector variable rather than $r$
% Vector from point A to B
% @sample \vectft[q]{A}{B}[\ms{avg}]: Add additional subscript (here $\ms{avg}$) to the given vector
%%
\ProvideDocumentCommand{\vectft}{ O{r} m m O{} }{%
  \vect{#1}_{%
    \ms{%
      #2%
      \protect{%
        \tikz[baseline=-0.5ex]{%
          \draw[-{Latex[width=1ex,length=0.33ex]},>=stealth'] (0,0) -- ++(1.33ex,0);%
        }%
      }%
      #3%
    }_{#4}%
  }%
}%


%%
% @group math
% @sample \eye: Write identity matrix of undefined size
% @sample \eye[3]: Identity matrix with index $3$ i.e., dimensions $\num{3} \times \num{3}$
%%
\ProvideDocumentCommand{\eye}{ o }{%
  \IfValueTF{#1}{%
    \mathbb{1}_{#1}%
  }{%
    \mathbb{1}%
  }%
}%


%%
% @group math
% @sample \zeros: Write "zero" matrix of undefined size
% @sample \zeros[3]: Zero matrix with index $3$ i.e., dimensions $\num{3} \times \num{3}$
%%
\ProvideDocumentCommand{\zeros}{ o }{%
  \IfValueTF{#1}{%
    \mathbb{0}_{#1}%
  }{%
    \mathbb{0}%
  }%
}%


%%
% @group math
% @sample \ones: Write "ones" matrix of undefined size
% @sample \ones[3]: Ones matrix with index $3$ i.e., dimensions $\num{3} \times \num{3}$
%%
\ProvideDocumentCommand{\ones}{ o }{%
  \IfValueTF{#1}{%
    \mathbb{1}_{#1}%
  }{%
    \mathbb{1}%
  }%
}%

%%
% @group math
% @sample \evecx: Unit axis coordinate vector along the $x$-axis
% @sample \evecx[\xi]: Name the unit axis coordinate vector $\xi$ rather than $e$
% @sample \evecx*: Avoids adding a hat to the vector nam
%%
\ProvideDocumentCommand{\evecx}{ s O{e} }{%
  \IfBooleanTF{#1}{%
    \evec*[#2]{x}%
  }{%
    \evec[#2]{x}%
  }%
}%

%%
% @group math
% @sample \evecy: Unit axis coordinate vector along the $y$-axis
% @sample \evecy[\xi]: Name the unit axis coordinate vector $\xi$ rather than $e$
% @sample \evecy*: Avoids adding a hat to the vector nam
%%
\ProvideDocumentCommand{\evecy}{ s O{e} }{%
  \IfBooleanTF{#1}{%
    \evec*[#2]{y}%
  }{%
    \evec[#2]{y}%
  }%
}%

%%
% @group math
% @sample \evecz: Unit axis coordinate vector along the $z$-axis
% @sample \evecz[\xi]: Name the unit axis coordinate vector $\xi$ rather than $e$
% @sample \evecz*: Avoids adding a hat to the vector nam
%%
\ProvideDocumentCommand{\evecz}{ s O{e} }{%
  \IfBooleanTF{#1}{%
    \evec*[#2]{z}%
  }{%
    \evec[#2]{z}%
  }%
}%

%%
% @group math
% @sample \innerp{a}{b}: Inner product of arguments $a$ and $b$
% @sample \innerp*{a}{b}: Conjugate inner product of arguments $a$ and $b$
%%
\ProvideDocumentCommand{\innerp}{ s m m }{%
  \def\innerpp{\langle #2 \, , #3 \rangle}%
  \IfBooleanTF{#1}{%
    \overline{\innerpp}%
  }{%
    \innerpp%
  }%
}

%%
% @group math
% @sample \vectset{a;b;c}: Vectorial set of some variables
%%
\ProvideDocumentCommand{\vectset}{ >{\SplitList{;}}m }{%
  \langle%
  {\ProcessList{#1}{\vectsetitem}}%
  \rangle%
}%
\providecommand\vectsetitem[1]{#1\let\vectsetitem\vectsetitema}
\providecommand\vectsetitema[1]{; #1}

%%
% @group math
% @sample \kronecker: Write the Kronecker delta function
% @sample \kronecker[i][j]: Write the Kronecker delta function for the two indices ${}_{i}$ and ${}_{j}$
%%
\ProvideDocumentCommand{\kronecker}{ O{i} O{j} }{%
  \delta_{#1#2}%
}%


%%
% @group math
% @sample \dirac: Dirac delta function
%%
\ProvideDocumentCommand{\dirac}{ }{%
  \delta%
}%


%%
% @group math
% @sample \symcorrected: Symbol for corrected values
%%
\ProvideDocumentCommand{\symcorrected}{ }{%
  \mc{cor}%
}%

%%
% @group math
% @sample \subcorrected: Subscript for corrected values
%%
\ProvideDocumentCommand{\subcorrected}{ }{%
  \ms{\symcorrected}%
}%

%%
% @group math
% @sample \symuncorrected: Symbol for uncorrected values
%%
\ProvideDocumentCommand{\symuncorrected}{ }{%
  \mc{unc}%
}%

%%
% @group math
% @sample \subuncorrected: Subscript for uncorrected values
%%
\ProvideDocumentCommand{\subuncorrected}{ }{%
  \ms{\symuncorrected}%
}%

%%
% @group math
% @sample \const: Mathematical string stating "constant"
%%
\ProvideDocumentCommand{\const}{ }{%
  \text{const}%
}%

%%
% @group math
% @sample \subconst: Subscript index for a "const"ant variable/value
%%
\ProvideDocumentCommand{\subconst}{ }{%
  \ms{const}%
}%

%%
% @group math
% @sample \heaviside: Gives the heaviside function denotation
% @sample \heaviside{x}: Gives the heaviside function of $x$ \textIe for $x \equiv 0$.
%%
\ProvideDocumentCommand{\heaviside}{ g }{%
  H%
  % \mathds{H}%
  \IfValueT{#1}{%
    \of{#1}%
  }%
}%

%%
% @group math
% @sample \polydeg: Degree of a polynomial $p$ or polynomial function $f \of{x}$ \textIe its highest power. Some may also call this the degree.
%%
\ProvideDocumentCommand{\polydeg}{ }{%
  d%
}%

%%
% @group math
% @sample \ceil{x}: Ceil its argument
% @see mathtools
%%
% \DeclarePairedDelimiterX{\ceil}[1]{\lceil}{\rceil}{%
%   \ifblank{#1}{\:\cdot\:}{#1}%
% }%

%%
% @group math
% @sample \floor{x}: Floor its argument
% @see mathtools
%%
% \DeclarePairedDelimiterX{\floor}[1]{\lfloor}{\rfloor}{%
%   \ifblank{#1}{\:\cdot\:}{#1}%
% }%

%%
% @group math
% @sample \residual: Vectorial formulation of an arbitrary residual
% @sample \residual*: Scalar formulation of an arbitrary residual
%%
\ProvideDocumentCommand{\residual}{ s }{%
  \IfBooleanTF{#1}{%
    e%
  }{%
    \vect{e}%
  }%
}%


%%
% @group math
% @sample \threshold: Some threshold
%%
\ProvideDocumentCommand{\threshold}{ }{%
  \epsilon%
}%

%%
% @group math
% @sample \itervar: Variable of an iteration loop
%%
\ProvideDocumentCommand{\itervar}{ s }{%
  \IfBooleanTF{#1}{%
    x%
  }{
    \vect{x}%
  }%
}%

%%
% @group math
% @sample \iterstep: Variable of an iteration step
%%
\ProvideDocumentCommand{\iterstep}{ s }{%
  \IfBooleanTF{#1}{%
    \Delta x%
  }{
    \Delta \vect{x}%
  }%
}%

%%
% @group math
% @sample \iterindex: Iteration index variable
%%
\ProvideDocumentCommand{\iterindex}{ }{%
  k%
}


%%
% @group math
% @sample \lerp{a_{0}}{a_{1}}: Linear interpolation between $a_{0}$ and $a_{1}$
% @sample \lerp[\xi]{a_{0}}{a_{1}}: Linear interpolation using $\xi$ as running variable
\ProvideDocumentCommand{\lerp}{ O{t} m m }{%
  \parentheses*{%
    1%
    -%
    #1%
  } \,%
  #2%
  +%
  #1 \,%
  #3%
}


%%
% @group math
% @sample \newtondamping: Variable representing damped scaling factor of Newton's method
\ProvideDocumentCommand{\newtondamping}{ }{%
  \alpha%
}


%%
% @sample \SIinterval{1}{2}{\meter}: Creates an SI-compliant interval of numbers.
% @sample \SIinterval[left-brace={]}]{1}{2}{\meter}: Pass additional options to the underlying `\interval` macro call.
%%
\ProvideDocumentCommand{\SIinterval}{ O{} m m m }{%
  \interval[#1]{#2}{#3}\,\si{#4}%
}%


%%
% @sample \SIset{1;2;3;4}{\second}: Creates an SIlist that looks like a set of numbers
% @sample \SIset[round-precision=6]{1;2;3;4;}{\second}: Pass additional options down to the \latexinline|\SIset| macro call
%%
\ProvideDocumentCommand{\SIset}{ O{} m m }{%
  \SIlist[%
      open-bracket={\lbrace},%
      close-bracket={\rbrace},%
      list-separator={,},%
      list-pair-separator={,},%
      list-final-separator={,},%
      #1,%
    ]{#2}{#3}%
}%


%%
% @sample \SIsetlist{1;2;4}: Set of numbers 1 through 4
% @sample \SIsetlist[round-precision=6]{1;2;3;4}: Pass additional options to the \latexinline|\SIsetlist| macro call
%%
\ProvideDocumentCommand{\SIsetlist}{ O{} m m }{%
  \SIlist[%
      open-bracket={\lbrace},%
      close-bracket={\rbrace},%
      list-separator={,},%
      list-pair-separator={,\dots,},%
      list-final-separator={,\dots,},%
      #1,%
    ]{#2}{#3}%
}


%%
% @sample \numset{1;2;3;4}: Set of numbers 1 through 4
% @sample \numset[round-precision=6]{1;2;3;4}: Pass additional options to the \latexinline|\numset| macro call
%%
\ProvideDocumentCommand{\numset}{ s O{} m }{%
  \def\nl{%
    \numlist[%
      open-bracket={\lbrace},%
      close-bracket={\rbrace},%
      list-separator={,},%
      list-pair-separator={,},%
      list-final-separator={,},%
      #2,%
    ]{#3}%
  }%
  \IfBooleanTF{#1}{%
    \left\{%
      \nl%
    \right\}
  }{%
    \{%
      \nl%
    \}%
  }%
}


%%
% @sample \numsetlist{1;2;4}: Set of listed numbers 1 through 4
% @sample \numsetlist[round-precision=6]{1;2;4}: Pass additional options to the \latexinline|\numsetlist| macro call
%%
\ProvideDocumentCommand{\numsetlist}{ s O{} m }{%
  \def\nl{%
    \numlist[%
      open-bracket={\lbrace},%
      close-bracket={\rbrace},%
      list-separator={\, ,},%
      list-pair-separator={\, , \dotsc ,},%
      list-final-separator={\, , \dotsc ,},%
      #2,%
    ]{#3}%
  }%
  \IfBooleanTF{#1}{%
    \left\{%
      \nl%
    \right\}
  }{%
    \{%
      \nl%
    \}%
  }%
}
